<?php
/*
 * Plugin Name: ConcoursPhoto
 * File :  maintain.inc.php  
 */

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');


function plugin_install()
{
	global $prefixeTable, $conf;

//	$query = 'SHOW TABLES LIKE "' . $prefixeTable . 'concours"';
//	$result = pwg_query($query);
//	if (!pwg_db_fetch_array($result))
	{
	// Concours description
		$q = 'CREATE TABLE IF NOT EXISTS  `' . $prefixeTable . 'concours` (
				`id` smallint(5) NOT NULL,
				`create_date` datetime NOT NULL,
				`name` text NOT NULL,
				`descr` varchar(255) default NULL,
				`begin_date` datetime NOT NULL,
				`end_date` datetime NOT NULL,
				`category` smallint(5) default NULL,
				`groups` varchar(255) default NULL,
				`method` smallint(5) default 1 NOT NULL,
				`guest` Boolean default FALSE,
				
				PRIMARY KEY  (`id`)
				) DEFAULT CHARSET=utf8;';
		pwg_query($q);

	// Concours description detail (criterias)
		$q = 'CREATE TABLE IF NOT EXISTS  `' . $prefixeTable . 'concours_detail` (
				`id` smallint(5) NOT NULL,
				`id_concours` smallint(5) NOT NULL,
				`criteria_id` smallint(5) NOT NULL,
				`name` text NOT NULL,
				`descr` varchar(255) default NULL,
				`min_value` int default 0,
				`max_value` int default 0,
				`ponderation` int default 1,
				`uppercriteria` smallint(5) default NULL,
				
				PRIMARY KEY  (`id`),
				FOREIGN KEY (`id_concours`) REFERENCES ' . $prefixeTable . 'concours(id)
				) DEFAULT CHARSET=utf8;';
		pwg_query($q);


	// Concours notation (by users)
		$q = 'CREATE TABLE IF NOT EXISTS  `' . $prefixeTable . 'concours_data` (
				`id` smallint(5) NOT NULL,
				`id_concours` smallint(5) NOT NULL,
				`user_id` smallint(5) NOT NULL,
				`create_date` datetime NOT NULL,
				`img_id` smallint(5) NOT NULL,
				`datas` longtext default NULL,
				`comment` longtext default NULL,				
				`ipguest` longtext default NULL,
				PRIMARY KEY  (`id`)
				) DEFAULT CHARSET=utf8;';
		pwg_query($q);
		
	// Concours result (synthesis)
		$q = 'CREATE TABLE IF NOT EXISTS  `' . $prefixeTable . 'concours_result` (
				`id_concours` smallint(5) NOT NULL,
				`img_id` smallint(5) NOT NULL,
				`date` datetime NOT NULL,
				`note` float default 0,
				`datas` longtext default NULL,
				`file_name` longtext default NULL,
				`moyenne` float default 0,
				`moderation1` float default 0,
				`moderation2` float default 0,
				`nbvotant` smallint(5) default 0,
				
				PRIMARY KEY  (`img_id`, `id_concours`),
				FOREIGN KEY (`id_concours`) REFERENCES ' . $prefixeTable . 'concours(id)				
				) DEFAULT CHARSET=utf8;';
		pwg_query($q);
		
	// Default values  insertion
    $q = "INSERT INTO `" . $prefixeTable . "concours` 
				( `id`,
				`create_date`, 
				`name`, 
				`descr`, 
				`begin_date`, 
				`end_date`, 
				`category`, 
				`groups`)
			VALUES (0, now(), 'Default', 'default values', now(), now(), NULL, NULL);";
    pwg_query($q);

    // Default values for criterias (concours_id=0)
    $q = "INSERT INTO `" . $prefixeTable . "concours_detail` 
				(`id`,
				`id_concours` , 
				`criteria_id` , 
				`name`, 
				`descr`, 
				`min_value`, 
				`max_value`, 
				`ponderation` ,
				`uppercriteria`)
			VALUES (1, 0, 1, 'Artistique', 'Artistique', 0, 10, 1, NULL),
			 (2, 0, 2, 'Respect du sujet', 'Sujet en rapport avec le theme', 0, 1, 1, 1),
			 (3, 0, 3, 'Sujet bien identifié', 'Sans ambiguite', 0, 2, 1, 1),
			 (4, 0, 4, 'Traitement du sujet', 'Expression/Attitude/mouvement', 0, 2, 1, 1),
			 (5, 0, 5, 'Mise en valeur du sujet', 'Cadrage/Harmonie de la composition/Esthetique de l\'image/Choix de l\'eclairage', 0, 5, 1, 1),

			 (6, 0, 6, 'Technique', 'Technique', 0, 6, 1, NULL),
			 (7, 0, 7, 'Nettete de l\'image', 'Etagement des plans/Pique de l\'image', 0, 3, 1, 6),
			 (8, 0, 8, 'Rendu des couleurs (ou gris)', 'Teintes/Staurations', 0, 1, 1, 6),
			 (9, 0, 9, 'Exposition', 'Equilibre hautes/basses lumieres', 0, 2, 1, 6),

			 (10, 0, 10, 'Coup de coeur', 'coup de coeur', 0, 4, 1, NULL),
			 (11, 0, 11, 'Emotion spontanee', 'emotion spontanee', 0, 2, 1, 10),
			 (12, 0, 12, 'Adhesion au choix artistique', 'Adhesion au choix artistique', 0, 2, 1, 10);";
			 
    pwg_query($q);

	$query = '
	SELECT param
	FROM '.CONFIG_TABLE.'
	WHERE param = "concoursphoto"
	;';
  $count = pwg_db_num_rows(pwg_query($query));
  
  if ($count == 0)
  {
    $q = '
    INSERT INTO '.CONFIG_TABLE.' (param,value,comment)
    VALUES ("concoursphoto","","Configuration Concours Photo")
    ;';

    pwg_query($q);
  }



    
    
/*	
	// TEST INSERTION INTO DB (Goupe test =1)
    $q = "INSERT INTO `" . $prefixeTable . "concours` 
				( `id`,
				`create_date`, 
				`name`, 
				`descr`, 
				`begin_date`, 
				`end_date`, 
				`category`, 
				`groups`)
			VALUES (1, now(), 'Test', 'Test Concours', now(), '2019-09-02 18:08:00', 2, 1);";
    pwg_query($q);
	
    $q = "INSERT INTO `" . $prefixeTable . "concours_data` 
				(`id` ,
				`id_concours` ,
				`user_id` ,
				`create_date` ,
				`img_id` ,
				`datas` )
			VALUES (1, 1, 3, now(), 54, \"2=1;3=1;4=2;5=3;7=1;8=0;9=0,5;11=1,5;12=2\");";
    pwg_query($q);
    $q = "INSERT INTO `" . $prefixeTable . "concours_detail` 
				(`id`,
				`id_concours` , 
				`criteria_id` , 
				`name`, 
				`descr`, 
				`min_value`, 
				`max_value`, 
				`ponderation` ,
				`uppercriteria`)
			VALUES (13, 1, 1, 'Artistique', 'Artistique', 0, 10, 1, NULL),
			 (14, 1, 2, 'Respect du sujet', 'Sujet en rapport avec le theme', 0, 1, 1, 1),
			 (15, 1, 3, 'Sujet bien identifié', 'Sans ambiguite', 0, 2, 1, 1),
			 (16, 1, 4, 'Traitement du sujet', 'Expression/Attitude/mouvement', 0, 2, 1, 1),
			 (17, 1, 5, 'Mise en valeur du sujet', 'Cadrage/Harmonie de la composition/Esthetique de l\'image/Choix de l\'eclairage', 0, 5, 1, 1),

			 (18, 1, 6, 'Technique', 'Technique', 0, 6, 1, NULL),
			 (19, 1, 7, 'Nettete de l\'image', 'Etagement des plans/Pique de l\'image', 0, 3, 1, 6),
			 (20, 1, 8, 'Rendu des couleurs (ou gris)', 'Teintes/Staurations', 0, 1, 1, 6),
			 (21, 1, 9, 'Exposition', 'Equilibre hautes/basses lumieres', 0, 2, 1, 6),

			 (22, 1, 10, 'Coup de coeur', 'coup de coeur', 0, 4, 1, NULL),
			 (23, 1, 11, 'Emotion spontanee', 'emotion spontanee', 0, 2, 1, 10),
			 (24, 1, 12, 'Adhesion au choix artistique', 'Adhesion au choix artistique', 0, 2, 1, 10);";
			 
    pwg_query($q);
	// END TEST INSERTION 
*/
	
	}

}

function plugin_activate()
{
  global $prefixeTable;

  // Check if upgrade is needed (from 1.0.0)
  $query = 'SHOW FULL COLUMNS FROM ' . $prefixeTable . 'concours_result;';
  $result = pwg_db_num_rows(pwg_query($query));

//  $result = array_from_query($query, 'Field');
  if ($result < 7)	// only 6 datas on previous database
  {
    upgrade_concoursresult_from_100();
  }
  elseif ($result < 10) // only 8 datas on previous database
  {
    upgrade_concoursresult_from_200();
  }
  
  // Check if upgrade is needed (from 1.0.0)
  $query = 'SHOW FULL COLUMNS FROM ' . $prefixeTable . 'concours;';
//  $result = array_from_query($query, 'Field');
  $result = pwg_db_num_rows(pwg_query($query));
  if ($result < 7)	// only 6 datas on previous database
  {
    upgrade_concours_from_100();
  }
  
}

function plugin_uninstall()
{
    global $prefixeTable;

	$q = 'DROP TABLE ' . $prefixeTable . 'concours, 
	' . $prefixeTable . 'concours_detail, 
	' . $prefixeTable . 'concours_data,
	' . $prefixeTable . 'concours_result	;';
    pwg_query($q);

    $q = '
      DELETE FROM '.CONFIG_TABLE.'
      WHERE param="concoursphoto" LIMIT 1
    ;';
    pwg_query($q);

}

// Add new parameter in database in version 1.0.1:
// - moy : moyenne of global note with all participant
// - nbvotant : nb of vote for an image
// - method = type of rank calculation (1-> total; 2-> moyenne)
function upgrade_concoursresult_from_100()
{
	global $prefixeTable;
	// Add new parameters
	$query = 'ALTER TABLE ' . $prefixeTable . 'concours_result
	ADD `moyenne` float default 0 AFTER `note`,
	ADD `nbvotant` smallint(5) default 0 AFTER `moyenne`
	;';

	pwg_query($query);
	
	// TODO : Recalcul the moyenne and the nb of participation if the table still exist for the selected concours

	$query = 'ALTER TABLE ' . $prefixeTable . 'concours
	ADD	`method` smallint(5) default 1 NOT NULL
	;';

	pwg_query($query);
  
}

// Add new parameter in database in version 2.9.0:
// - moderation1 : global result with method moderation 1
// - moderation2 : global result with method moderation 1
function upgrade_concoursresult_from_200()
{
	global $prefixeTable;
	// Add new parameters
	$query = 'ALTER TABLE ' . $prefixeTable . 'concours_result
	ADD `moderation1` float default 0 AFTER `moyenne`,
	ADD `moderation2` float default 0 AFTER `moderation1`
	;';

	pwg_query($query); 
}


// Add new parameter in database in version 2.0.0:
// - guest : boolean to allow guest to use this function (concours)
function upgrade_concours_from_100()
{
	global $prefixeTable;
	// Add new parameters
	$query = 'ALTER TABLE ' . $prefixeTable . 'concours
	ADD `guest` boolean default FALSE AFTER `method`
	;';

	pwg_query($query);
 	// Add new parameters
	$query = 'ALTER TABLE ' . $prefixeTable . 'concours_data
	ADD `ipguest` longtext default NULL AFTER `comment`
	;';

	pwg_query($query);
 
}

?>